function createSummernote(containerID, varList, btnName, btnToolTip) {

    var VariableDropdown = function(context) {
        var ui = $.summernote.ui;
        var list = varList;
        var range;
		
		var listString="";
		
		for (var key in list) {
			listString += "<li data-val='" + list[key] + "'><a href='#'>"+ key +"</a></li>";
		}

        var button = ui.buttonGroup([
            ui.button({
                click: function() {
                    $('#' + containerID).summernote('saveRange');
                },
                className: 'dropdown-toggle',
                contents: '<span class="fa fa-database"></span>'+btnName+'<span class="caret"></span>',
                tooltip: btnToolTip,
                data: {
                    toggle: 'dropdown'
                }
            }),
            ui.dropdown({
                className: '',
                contents: listString,
                callback: function($dropdown) {
                    $dropdown.find('li').each(function() {
                        $(this).click(function() {
                            $('#' + containerID).summernote('restoreRange');

                            $('#' + containerID).summernote('editor.insertText', $(this).data("val"));
                        });
                    });
                }
            })
        ]);
        return button.render();
    }

    $('#' + containerID).summernote({
        height: 500,
		dialogsInBody: false,
        toolbar: [
            ['style', ['style']],
            ['font', ['bold', 'italic', 'underline', 'clear']],
            ['fontname', ['fontname']],
            ['color', ['color']],
            ['para', ['ul', 'ol', 'paragraph']],
            ['height', ['height']],
            ['table', ['table']],
            ['insert', ['link', 'picture', 'hr']],
            ['view', ['fullscreen', 'codeview']],
            ['help', ['help']],
            ['varia', ['varia']]
        ],
        buttons: {
            varia: VariableDropdown
        }
    });
}