(
	function()
	{
		"use strict"

		var oSignaturePad

		oSignaturePad =
		{
			/*
			   ###    ######## ######## ########  #### ########  ##     ## ######## ########  ######
			  ## ##      ##       ##    ##     ##  ##  ##     ## ##     ##    ##    ##       ##    ##
			 ##   ##     ##       ##    ##     ##  ##  ##     ## ##     ##    ##    ##       ##
			##     ##    ##       ##    ########   ##  ########  ##     ##    ##    ######    ######
			#########    ##       ##    ##   ##    ##  ##     ## ##     ##    ##    ##             ##
			##     ##    ##       ##    ##    ##   ##  ##     ## ##     ##    ##    ##       ##    ##
			##     ##    ##       ##    ##     ## #### ########   #######     ##    ########  ######
			*/
			// <editor-fold desc="attributes">
			sUrl:	"",

			oSignaturePad:	null,

			oElements:
			{
				canvas:	null,
				clear:	null,
				save:	null,
			},
			// </editor-fold>
			/*
			   ###     ######   ######  ########  ######   ######   #######  ########   ######
			  ## ##   ##    ## ##    ## ##       ##    ## ##    ## ##     ## ##     ## ##    ##
			 ##   ##  ##       ##       ##       ##       ##       ##     ## ##     ## ##
			##     ## ##       ##       ######    ######   ######  ##     ## ########   ######
			######### ##       ##       ##             ##       ## ##     ## ##   ##         ##
			##     ## ##    ## ##    ## ##       ##    ## ##    ## ##     ## ##    ##  ##    ##
			##     ##  ######   ######  ########  ######   ######   #######  ##     ##  ######
			*/
			// <editor-fold desc="accessors">
			get elements()
			{
				return this.oElements
			},
			get signaturePad()
			{
				return this.oSignaturePad
			},
			set signaturePad(oSignaturePad)
			{
				this.oSignaturePad = oSignaturePad
			},
			get url()
			{
				return this.sUrl
			},
			set url(sUrl)
			{
				this.sUrl = sUrl
			},
			// </editor-fold>
			/*
			######## ##     ## ######## ##    ## ########  ######
			##       ##     ## ##       ###   ##    ##    ##    ##
			##       ##     ## ##       ####  ##    ##    ##
			######   ##     ## ######   ## ## ##    ##     ######
			##        ##   ##  ##       ##  ####    ##          ##
			##         ## ##   ##       ##   ###    ##    ##    ##
			########    ###    ######## ##    ##    ##     ######
			*/
			// <editor-fold desc="events">
			onClearClicked()
			{
				this.clear()
			},
			onResize()
			{
				this.resize()
			},
			onSaveClicked()
			{
				this.save()
				.catch
				(
					(oError) =>
					{
						this._error
						(
								"Saving failed! Failed to upload image!",
							{
								object:	"signaturePad",
								method:	"onSaveClicked",
								xhr:	oError,
							}
						)
					}
				)
			},
			onUnload()
			{
				this.finalize()
			},
			// </editor-fold>
			/*
			 ######  ######## ########  ##     ##  ######  ########  #######  ########   ######
			##    ##    ##    ##     ## ##     ## ##    ##    ##    ##     ## ##     ## ##    ##
			##          ##    ##     ## ##     ## ##          ##    ##     ## ##     ## ##
			 ######     ##    ########  ##     ## ##          ##    ##     ## ########   ######
			      ##    ##    ##   ##   ##     ## ##          ##    ##     ## ##   ##         ##
			##    ##    ##    ##    ##  ##     ## ##    ##    ##    ##     ## ##    ##  ##    ##
			 ######     ##    ##     ##  #######   ######     ##     #######  ##     ##  ######
			*/
			// <editor-fold desc="structors">
			initialize(oData)
			{
				this.elements.canvas = oData.elements.canvas
				this.elements.clear = oData.elements.clear
				this.elements.save = oData.elements.save

				this.onClearClicked	= this.onClearClicked	.bind(this)
				this.onResize	= this.onResize	.bind(this)
				this.onSaveClicked	= this.onSaveClicked	.bind(this)
				this.onUnload	= this.onUnload	.bind(this)

				this.elements.clear	.addEventListener("click"	, this.onClearClicked)
				this.elements.save	.addEventListener("click"	, this.onSaveClicked)
				window	.addEventListener("resize"	, this.onResize)
				window	.addEventListener("beforeunload"	, this.onUnload)

				this.signaturePad	= new SignaturePad(this.elements.canvas)
				this.url	= oData.url

				this.resize()

				return this
			},
			finalize()
			{
				this.signaturePad.off()
				this.signaturePad = null

				this.elements.clear	.removeEventListener("click"	, this.onClearClicked)
				this.elements.save	.removeEventListener("click"	, this.onSaveClicked)
				window	.removeEventListener("resize"	, this.onResize)
				window	.removeEventListener("beforeunload"	, this.onUnload)

				return this
			},
			// </editor-fold>
			/*
			##     ## ######## ######## ##     ##  #######  ########   ######
			###   ### ##          ##    ##     ## ##     ## ##     ## ##    ##
			#### #### ##          ##    ##     ## ##     ## ##     ## ##
			## ### ## ######      ##    ######### ##     ## ##     ##  ######
			##     ## ##          ##    ##     ## ##     ## ##     ##       ##
			##     ## ##          ##    ##     ## ##     ## ##     ## ##    ##
			##     ## ########    ##    ##     ##  #######  ########   ######
			*/
			// <editor-fold desc="methods">
			/*
			########  ########  #### ##     ##    ###    ######## ########
			##     ## ##     ##  ##  ##     ##  ##   ##     ##    ##
			########  ########   ##  ##     ## ##     ##    ##    ######
			##        ##   ##    ##   ##   ##  #########    ##    ##
			##        ##     ## ####    ###    ##     ##    ##    ########
			*/
			// <editor-fold desc="private">
			_error(sMessage, oData, oPromise)
			{
				if(oData !== undefined)
				{
					if(oData.object !== undefined)
					{
						sMessage += `\nObject: ${oData.object}`
						if(oData.method !== undefined)
						{
							sMessage += `\nMethod: ${oData.method}`
						}
						if(oData.parameter !== undefined)
						{
							sMessage += `\nParameter: ${oData.parameter}`

							if(oData.type !== undefined)
							{
								sMessage += `\nType: expected ${oData.type.expected} found ${oData.type.found}`
							}
							if(oData.value !== undefined)
							{
								sMessage += `\nValue: expected ${oData.value.expected} found ${oData.value.found}`
							}
						}
					}
					if(oData.xhr !== undefined)
					{
						if(oData.xhr.status !== undefined)
						{
							sMessage += `\nXHR status: ${oData.xhr.status}`
						}
						if(oData.xhr.text !== undefined)
						{
							sMessage += `\nXHR text: ${oData.xhr.text}`
						}
					}
					if(oData.message !== undefined)
					{
						sMessage += oData.message
					}
				}

				if(oPromise !== undefined)
				{
					oPromise.reject(sMessage)
				}
				else
				{
					throw new Error(sMessage)
				}

				return this
			},
			_generateTrimmedBlob()
			{
				return new Promise
				(
					(fResolve, fReject) =>
					{
						const nPadding = 3

						var	oCroppedCanvas,
							oCroppedCanvasContext,
							oData,
							oPixel,
							fSort

						fSort = (a, b) => a-b

						oCroppedCanvas	= document.createElement("canvas")
						oCroppedCanvas.height	= this.elements.canvas.height
						oCroppedCanvas.width	= this.elements.canvas.width
						oCroppedCanvasContext	= oCroppedCanvas.getContext("2d")

						oCroppedCanvasContext.drawImage(this.elements.canvas, 0, 0)

						oData	= oCroppedCanvasContext.getImageData(0, 0,  oCroppedCanvas.width, oCroppedCanvas.height)
						oPixel	= {x: [], y: []}

						for(let y = 0; y < oCroppedCanvas.height; y++)
						{
							for(let x = 0; x < oCroppedCanvas.width; x++)
							{
								if(oData.data[(y * oCroppedCanvas.width + x) * 4 + nPadding] > 0)
								{
									oPixel.x.push(x)
									oPixel.y.push(y)
								}
							}
						}

						oPixel.x.sort(fSort)
						oPixel.y.sort(fSort)

						oData = oCroppedCanvasContext.getImageData(oPixel.x[0], oPixel.y[0], oCroppedCanvas.width, oCroppedCanvas.height)
						oCroppedCanvas.height	= oPixel.y[oPixel.y.length - 1] - oPixel.y[0]
						oCroppedCanvas.width	= oPixel.x[oPixel.x.length - 1] - oPixel.x[0]

						oCroppedCanvasContext.putImageData(oData, 0, 0)

						oCroppedCanvas.toBlob(() => {fResolve()}, "image/png")
					}
				)
			},
			_xhr: function(oData)
			{
				return new Promise
				(
					(fResolve, fReject) =>
					{
						var	oXhr

						oXhr = new XMLHttpRequest()

						oXhr.addEventListener
						(
							"load",
							() =>
							{
								if(oXhr.status >= 200 && oXhr.status < 300)
								{
									fResolve(oXhr.response)
								}
								else
								{
									fReject({status: oXhr.status, text: oXhr.statusText})
								}
							}
						)
						oXhr.addEventListener
						(
							"error",
							() =>
							{
								fReject({status: oXhr.status, text: oXhr.statusText})
							}
						)

						oXhr.open(oData.method, oData.url)
						oXhr.send(oData.data)
					}
				)
			},
			// </editor-fold>
			/*
			########  ##     ## ########  ##       ####  ######
			##     ## ##     ## ##     ## ##        ##  ##
			########  ##     ## ########  ##        ##  ##
			##        ##     ## ##     ## ##        ##  ##
			##         #######  ########  ######## ####  ######
			*/
			// <editor-fold desc="pulic">
			clear()
			{
				this.signaturePad.clear()
			},
			resize(nRatio)
			{
				var oContext

				oContext	= this.elements.canvas.getContext("2d")
				nRatio	= nRatio || Math.max(window.devicePixelRatio || 1, 1)

				this.elements.canvas.width	= this.elements.canvas.offsetWidth * nRatio
				this.elements.canvas.height	= this.elements.canvas.offsetHeight * nRatio

				oContext.scale(nRatio, nRatio);
				this.signaturePad.clear()

				return this
			},
			save()
			{
				return new Promise
				(
					(fResolve, fReject) =>
					{
						var oFormData

						oFormData = new FormData()

						this._generateTrimmedBlob()
						.then
						(
							(oBlob) =>
							{
								oFormData.append("signature", oBlob)

								this._xhr
								({
									data:	oBlob,
									method:	"POST",
									url: this.url,
								})
								.then(() => {fResolve()})
								.catch((oError) => {fReject(oError)})
							}
						)
					}
				)
			},
			// </editor-fold>
			// </editor-fold>
		}

		/*
		######## ##     ## ########   #######   ######  ##     ## ########  ########
		##        ##   ##  ##     ## ##     ## ##    ## ##     ## ##     ## ##
		##         ## ##   ##     ## ##     ## ##       ##     ## ##     ## ##
		######      ###    ########  ##     ##  ######  ##     ## ########  ######
		##         ## ##   ##        ##     ##       ## ##     ## ##   ##   ##
		##        ##   ##  ##        ##     ## ##    ## ##     ## ##    ##  ##
		######## ##     ## ##         #######   ######   #######  ##     ## ########
		*/
		// <editor-fold desc="exposure">
		if(window.metasec === undefined)
		{
			window.metasec = {}
		}
		window.metasec.signaturePad = oSignaturePad
		// </editor-fold>
	}
)()
