(
	function()
	{
		"use strict"

		var oPhotoCapture

		oPhotoCapture =
		{
			/*
			   ###    ######## ######## ########  #### ########  ##     ## ######## ########  ######
			  ## ##      ##       ##    ##     ##  ##  ##     ## ##     ##    ##    ##       ##    ##
			 ##   ##     ##       ##    ##     ##  ##  ##     ## ##     ##    ##    ##       ##
			##     ##    ##       ##    ########   ##  ########  ##     ##    ##    ######    ######
			#########    ##       ##    ##   ##    ##  ##     ## ##     ##    ##    ##             ##
			##     ##    ##       ##    ##    ##   ##  ##     ## ##     ##    ##    ##       ##    ##
			##     ##    ##       ##    ##     ## #### ########   #######     ##    ########  ######
			*/
			// <editor-fold desc="attributes">
			bInitialized:	false,
			bIsRunning:	false,
			bPermission:	false,
			sUrl:	"/tmp/VideoSnapshotUpload/upload.php",

			oCanvasContext:	null,
			oStream:	null,

			oElements:
			{
				canvas:	null,
				submit:	null,
				target:	null,
				video:	null,
			},
			oDimesions:
			{
				width:    "320",
				height:	"240",

			},
			// </editor-fold>
			/*
			   ###     ######   ######  ########  ######   ######   #######  ########   ######
			  ## ##   ##    ## ##    ## ##       ##    ## ##    ## ##     ## ##     ## ##    ##
			 ##   ##  ##       ##       ##       ##       ##       ##     ## ##     ## ##
			##     ## ##       ##       ######    ######   ######  ##     ## ########   ######
			######### ##       ##       ##             ##       ## ##     ## ##   ##         ##
			##     ## ##    ## ##    ## ##       ##    ## ##    ## ##     ## ##    ##  ##    ##
			##     ##  ######   ######  ########  ######   ######   #######  ##     ##  ######
			*/
			// <editor-fold desc="accessors">
			get canvasContext()
			{
				return this.oCanvasContext
			},
			set canvasContext(oCanvasContext)
			{
				this.oCanvasContext = oCanvasContext
			},
			get dimensions()
			{
				return this.oDimesions
			},
			get elements()
			{
				return this.oElements
			},
			get hasPermission()
			{
				return this.bPermission
			},
			set hasPermission(bPermission)
			{
				this.bPermission = bPermission
			},
			get isInitialized()
			{
				return this.bInitialized
			},
			set isInitialized(bInitialized)
			{
				this.bInitialized = bInitialized
			},
			get isRunning()
			{
				return this.bIsRunning
			},
			set isRunning(bIsRunning)
			{
				this.bIsRunning = bIsRunning
			},
			get stream()
			{
				return this.oStream
			},
			set stream(oStream)
			{
				this.oStream = oStream
			},
			get target()
			{
				return this.elements.target
			},
			set target(eElement)
			{
				this.elements.target = eElement
			},
			get url()
			{
				return this.sUrl
			},
			// </editor-fold>
			/*
			######## ##     ## ######## ##    ## ########  ######
			##       ##     ## ##       ###   ##    ##    ##    ##
			##       ##     ## ##       ####  ##    ##    ##
			######   ##     ## ######   ## ## ##    ##     ######
			##        ##   ##  ##       ##  ####    ##          ##
			##         ## ##   ##       ##   ###    ##    ##    ##
			########    ###    ######## ##    ##    ##     ######
			*/
			// <editor-fold desc="events">
			onPermissionReceived()
			{
				this.hasPermission = true
			},
			onStreamReceived(oStream)
			{
				this.elements.video.srcObject = oStream
				this.elements.video.play()
			},
			onSubmit()
			{
				this.capture().upload()
			},
			// </editor-fold>
			/*
			 ######  ######## ########  ##     ##  ######  ########  #######  ########   ######
			##    ##    ##    ##     ## ##     ## ##    ##    ##    ##     ## ##     ## ##    ##
			##          ##    ##     ## ##     ## ##          ##    ##     ## ##     ## ##
			 ######     ##    ########  ##     ## ##          ##    ##     ## ########   ######
			      ##    ##    ##   ##   ##     ## ##          ##    ##     ## ##   ##         ##
			##    ##    ##    ##    ##  ##     ## ##    ##    ##    ##     ## ##    ##  ##    ##
			 ######     ##    ##     ##  #######   ######     ##     #######  ##     ##  ######
			*/
			// <editor-fold desc="structors">
			initialize(oDimensions)
			{
				if(oDimensions)
				{
					this.dimensions = oDimensions
				}

				this.onSubmit	= this.onSubmit	.bind(this)

				this.elements.canvas	= document.createElement("canvas")
				this.elements.canvas.width	= this.dimensions.width
				this.elements.canvas.height	= this.dimensions.height
				this.canvasContext	= this.elements.canvas.getContext("2d")
				this.elements.submit	= document.createElement("button")
				this.elements.submit.textContent = "Capture"
				this.elements.video	= document.createElement("video")
				this.elements.video.width	= this.dimensions.width
				this.elements.video.height	= this.dimensions.height

				this.elements.submit	.setAttribute("type", "button")

				this.elements.submit	.addEventListener("click"	, this.onSubmit	)

				this.isInitialized = true

				return this
			},
			finalize()
			{
				this.elements.canvas.remove()
				this.elements.canvas	= null
				this.elements.video.remove()
				this.elements.video	= null

				return this
			},
			// </editor-fold>
			/*
			##     ## ######## ######## ##     ##  #######  ########   ######
			###   ### ##          ##    ##     ## ##     ## ##     ## ##    ##
			#### #### ##          ##    ##     ## ##     ## ##     ## ##
			## ### ## ######      ##    ######### ##     ## ##     ##  ######
			##     ## ##          ##    ##     ## ##     ## ##     ##       ##
			##     ## ##          ##    ##     ## ##     ## ##     ## ##    ##
			##     ## ########    ##    ##     ##  #######  ########   ######
			*/
			// <editor-fold desc="methods">
			/*
			########  ########  #### ##     ##    ###    ######## ########
			##     ## ##     ##  ##  ##     ##  ##   ##     ##    ##
			########  ########   ##  ##     ## ##     ##    ##    ######
			##        ##   ##    ##   ##   ##  #########    ##    ##
			##        ##     ## ####    ###    ##     ##    ##    ########
			*/
			// <editor-fold desc="private">
			_isBlank()
			{
				var oBlankCanvas

				oBlankCanvas	= document.createElement("canvas")
				oBlankCanvas.width	= this.elements.canvas.width
				oBlankCanvas.height	= this.elements.canvas.height

				return this.elements.canvas.toDataURL() == oBlankCanvas.toDataURL()
			},
			_xhr: function(oData)
			{
				return new Promise
				(
					(fResolve, fReject) =>
					{
						var	oXhr

						oXhr = new XMLHttpRequest()

						oXhr.addEventListener
						(
							"load",
							() =>
							{
								if(oXhr.status >= 200 && oXhr.status < 300)
								{
									fResolve(oXhr.response)
								}
								else
								{
									fReject({status: oXhr.status, statusText: oXhr.statusText})
								}
							}
						)
						oXhr.addEventListener
						(
							"error",
							() =>
							{
								fReject({status: oXhr.status, statusText: oXhr.statusText})
							}
						)

						oXhr.open(oData.method, oData.url)
						oXhr.send(oData.data)
					}
				)
			},
			// </editor-fold>
			/*
			########  ##     ## ########  ##       ####  ######
			##     ## ##     ## ##     ## ##        ##  ##
			########  ##     ## ########  ##        ##  ##
			##        ##     ## ##     ## ##        ##  ##
			##         #######  ########  ######## ####  ######
			*/
			// <editor-fold desc="public">
			capture()
			{
				if(!this.hasPermission)
				{
					throw new Error("Missing video capture permission!")
				}

				this.canvasContext.drawImage(this.elements.video, 0, 0, this.dimensions.width, this.dimensions.height)
				this.stop().hide({submit: true, video: true,}).show({canvas: true})

				return this
			},
			clear()
			{
				this.canvasContext.clearRect(0, 0, this.elements.canvas.width, this.elements.canvas.height)
			},
			hide(oOptions)
			{
				if(oOptions)
				{
					if(oOptions.video)
					{
						this.elements.video.remove()
					}
					if(oOptions.canvas)
					{
						this.elements.canvas.remove()
					}
					if(oOptions.submit)
					{
						this.elements.submit.remove()
					}
				}

				return this
			},
			show(oOptions, eElement)
			{
				eElement	= eElement || this.elements.target
				oOptions	= oOptions || {submit: true, video: true,}

				if(oOptions)
				{
					Array.prototype.slice.call(eElement.children).forEach((eElement) => {eElement.remove()})

					if(oOptions.video)
					{
						eElement.appendChild(this.elements.video)
						this.elements.video.play()
					}
					if(oOptions.canvas)
					{
						eElement.appendChild(this.elements.canvas)
					}
					if(oOptions.submit)
					{
						eElement.appendChild(this.elements.submit)
					}
				}

				return this
			},
			start()
			{
				navigator.mediaDevices.getUserMedia({video: true})
				.then
				(
					(oStream) =>
					{
						this.onPermissionReceived()
						this.onStreamReceived(oStream)
						this.stream = oStream
					}
				)
				this.clear()

				this.isRunning = true

				return this
			},
			stop()
			{
				this.stream.getTracks().forEach((oTrack) => {oTrack.stop()})

				this.stream	= null
				this.isRunning	= false

				return this
			},
			upload()
			{
				if(!this.hasPermission)
				{
					throw new Error("Missing video capture permission!")
				}
				if(this._isBlank())
				{
					throw new Error("No photo has been taken!")
				}

				this.elements.canvas.toBlob
				(
					(oBlob) =>
					{
						var	oFormData = new FormData()

						oFormData.append("image", oBlob)
						this._xhr
						({
							data:	oFormData,
							method:	"POST",
							url:	`${this.url}?SID=${document.querySelector("#SID").value}&jau_id=${document.querySelector("#jau_id").value}`,
						})
					}
				)

				return this
			},
			// </editor-fold>
			// </editor-fold>
		}

		document.addEventListener
		(
			"DOMContentLoaded",
			function()
			{
				oPhotoCapture.initialize()
			}
		)

		/*
		######## ##     ## ########   #######   ######  ##     ## ########  ########
		##        ##   ##  ##     ## ##     ## ##    ## ##     ## ##     ## ##
		##         ## ##   ##     ## ##     ## ##       ##     ## ##     ## ##
		######      ###    ########  ##     ##  ######  ##     ## ########  ######
		##         ## ##   ##        ##     ##       ## ##     ## ##   ##   ##
		##        ##   ##  ##        ##     ## ##    ## ##     ## ##    ##  ##
		######## ##     ## ##         #######   ######   #######  ##     ## ########
		*/
		// <editor-fold desc="exposure">
		if(window.metasec === undefined)
		{
			window.metasec = {}
		}
		window.metasec.photoCapture = oPhotoCapture
		// </editor-fold>
	}
)()
