(
	function()
	{
		"use strict"

		const	oTranslator	=
		{
			/*
				TODO: Add l18n e.g. webextentions
				TODO: Add setting and query parameter for ui language
				TODO: Add dynamic messages
			*/
			/*
			   ###    ######## ######## ########  #### ########  ##     ## ######## ########  ######
			  ## ##      ##       ##    ##     ##  ##  ##     ## ##     ##    ##    ##       ##    ##
			 ##   ##     ##       ##    ##     ##  ##  ##     ## ##     ##    ##    ##       ##
			##     ##    ##       ##    ########   ##  ########  ##     ##    ##    ######    ######
			#########    ##       ##    ##   ##    ##  ##     ## ##     ##    ##    ##             ##
			##     ##    ##       ##    ##    ##   ##  ##     ## ##     ##    ##    ##       ##    ##
			##     ##    ##       ##    ##     ## #### ########   #######     ##    ########  ######
			*/
			// <editor-fold desc="attributes">
			bActive:	false	,
			sControlsSize:	"5vmin"	,
			sId:	null	,
			sLanguage:	null	,
			sName:	null	,
			sRole:	null	,
			bScrollable:	null	,

			aoClients:	[]	,
			aoData:	null	,

			oOverlay:	null	,
			oQuery:	{}	,

			oElements:
			{
				eActive:	null	,
				eAudio:	null	,
				eClients:	null	,
				eContent:	null	,
				eClient:	null	,
				eHome:	null	,
				eLanguage:	null	,
				eLanguages:	null	,
				eQuestion:	null	,
				eSentences:	null	,
			},
			oQueues:
			{
				oLocal:	new Map()	,
				oRemote:	null	,
				oCommands:	new Map()	,
			},
			oTimeouts:
			{
				nCommand:	1000	,
				nHighlight:	2500	,
				nIdle:	60000	,
				nPing:	300000	,
				nPong:	10000	,
				nRestartWait:	1000	,
				nWebsocket:	60000	,
			},
			oTimer:
			{
				nClientHighlight:	null	,
				nIdle:	null	,
				nKeepalive:	null	,
			},
			oWebSocket:
			{
				sUri:	"ws://" + window.location.hostname + ":33377"	,

				oSocket:	null	,
			},
			// </editor-fold>
			/*
			   ###     ######   ######  ########  ######   ######   #######  ########   ######
			  ## ##   ##    ## ##    ## ##       ##    ## ##    ## ##     ## ##     ## ##    ##
			 ##   ##  ##       ##       ##       ##       ##       ##     ## ##     ## ##
			##     ## ##       ##       ######    ######   ######  ##     ## ########   ######
			######### ##       ##       ##             ##       ## ##     ## ##   ##         ##
			##     ## ##    ## ##    ## ##       ##    ## ##    ## ##     ## ##    ##  ##    ##
			##     ##  ######   ######  ########  ######   ######   #######  ##     ##  ######
			*/
			// <editor-fold desc="accessors">
			_active: function(bActive)
			{
				if(bActive === undefined)
				{
					return this.bActive
				}

				this.bActive = bActive
				this.onActiveChanged(bActive)

				return this
			},
			_clients: function(aoValue)
			{
				if(aoValue === undefined)
				{
					return this.aoClients
				}

				this.aoClients = aoValue

				return this
			},
			_controlsSize: function(sControlsSize)
			{
				if(sControlsSize === undefined)
				{
					return this.sControlsSize
				}

				this.sControlsSize = sControlsSize
				document.documentElement.style.setProperty("--controls-size", sControlsSize)

				return this
			},
			_data: function(vData, oPhrases)
			{
				if(vData === undefined)
				{
					return this.aoData
				}
				if(typeof vData === "string" && oPhrases === undefined)
				{
					return this._data().find(sLanguage => sLanguage.language.code === vData)
				}

				if(oPhrases === undefined)
				{
					this.aoData = vData
				}
				else
				{
					this._data(vData).phrases = oPhrases
				}

				return this
			},
			_element: function(sElement, eElement)
			{
				sElement = "e" + sElement[0].toUpperCase() + sElement.slice(1)

				if(eElement === undefined)
				{
					return this.oElements[sElement]
				}

				this.oElements[sElement] = eElement

				return this
			},
			_id: function(sId)
			{
				if(sId === undefined)
				{
					return this.sId
				}

				this.sId = sId

				return this
			},
			_keepalive: function(sKey, sValue)
			{
				sKey = "n" + sKey[0].toUpperCase() + sKey.slice(1)

				if(sValue === undefined)
				{
					return this.oKeepalive[sKey]
				}

				this.oKeepalive[sKey] = sValue;

				return this
			},
			_language: function(sLanguage)
			{
				if(sLanguage === undefined)
				{
					return this.sLanguage
				}

				this.sLanguage = sLanguage

				return this
			},
			_name: function(sName)
			{
				if(sName === undefined)
				{
					return this.sName
				}

				this.sName = sName

				return this
			},
			_overlay: function(sType)
			{
				if(sType === undefined)
				{
					return this.oOverlay
				}

				if(sType === null)
				{
					this._overlay().destroy()
					this.oOverlay = null
				}
				else
				{
					let sContent

					if(this._overlay() !== null)
					{
						this._overlay(null)
					}
					switch(sType)
					{
						case "server":
							sContent = "Currently no operator available"
							break
						case "websocket":
							sContent = "No connection to server"
							break
					}
					this.oOverlay = new window.metasec.Overlay
					(
						document.body,
							"<span style=\""
						+		"background-color: #81B741;"
						+		"border: 1px solid #000000;"
						+		"color: #FFFFFF;"
						+		"font-size: 5vmin;"
						+		"padding: 1vmin;"
						+		"text-align: center;"
						+	"\">"
						+		sContent
						+	"</span>"
					)
					this._overlay().element.addEventListener("click", this.onHomeClicked)
				}

			},
			_queue: function(sQueue, oQueue)
			{
				sQueue = "o" + sQueue[0].toUpperCase() + sQueue.slice(1)

				if(oQueue === undefined)
				{
					return this.oQueues[sQueue]
				}

				this.oQueues[sQueue] = oQueue

				return this
			},
			_query: function()
			{
				window.location.search.substr(1).split("&").forEach
				(
					(sPair) =>
					{
						var asPair

						asPair = sPair.split("=")

						if(asPair[1] === "true" || asPair[1] === "false")
						{
							asPair[1] = asPair[1] === "true"
						}
						this.oQuery[asPair[0]] = asPair[1]
					}
				)

				this._query = function()
				{
					return this.oQuery
				}

				return this._query()
			},
			_role: function(sRole)
			{
				if(sRole === undefined)
				{
					return this.sRole
				}

				this.sRole = sRole
				this.onRoleChanged(sRole)

				return this
			},
			_scrollable: function(bScrollable)
			{
				if(bScrollable === undefined)
				{
					return this.bScrollable
				}

				this.bScrollable = bScrollable
				document.documentElement.style.setProperty("--scrollable", bScrollable ? "auto" : "hidden")

				return this
			},
			_timeout: function(sTimeout, nTimeout)
			{
				sTimeout = "n" + sTimeout[0].toUpperCase() + sTimeout.slice(1)

				if(nTimeout === undefined)
				{
					return this.oTimeouts[sTimeout]
				}

				this.oTimeouts[sTimeout] = nTimeout
			},
			_timer: function(sTimer, nTimer)
			{
				sTimer = "n" + sTimer[0].toUpperCase() + sTimer.slice(1)

				if(nTimer === undefined)
				{
					return this.oTimer[sTimer]
				}

				if(this.oTimer[sTimer] !== null)
				{
					window.clearTimeout(this.oTimer[sTimer])
				}
				this.oTimer[sTimer] = nTimer

				return this
			},
			_websocket: function(sUri)
			{
				if(sUri === undefined)
				{
					return this.oWebSocket.oSocket
				}

				if(sUri === null)
				{
					sUri = this.oWebSocket.sUri
				}
				if(this.oWebSocket.oSocket !== null)
				{
					this.oWebSocket.oSocket	.removeEventListener("close"	, this.onWebSocketClosed	)
					this.oWebSocket.oSocket	.removeEventListener("message"	, this.onWebSocketMessage	)
					this.oWebSocket.oSocket	.removeEventListener("open"	, this.onWebSocketOpen	)
				}

				this.oWebSocket.oSocket	= new WebSocket(sUri)
				this.oWebSocket.sUri	= sUri

				this.oWebSocket.oSocket	.addEventListener("close"	, this.onWebSocketClosed	)
				this.oWebSocket.oSocket	.addEventListener("message"	, this.onWebSocketMessage	)
				this.oWebSocket.oSocket	.addEventListener("open"	, this.onWebSocketOpen	)

				return this
			},
			// </editor-fold>
			/*
			######## ##     ## ######## ##    ## ########  ######
			##       ##     ## ##       ###   ##    ##    ##    ##
			##       ##     ## ##       ####  ##    ##    ##
			######   ##     ## ######   ## ## ##    ##     ######
			##        ##   ##  ##       ##  ####    ##          ##
			##         ## ##   ##       ##   ###    ##    ##    ##
			########    ###    ######## ##    ##    ##     ######
			*/
			// <editor-fold desc="events">
			onActionClicked:	function(oEvent)
			{
				if(oEvent.target.tagName !== "IMG")
				{
					oEvent.currentTarget.querySelector("img").click()
				}
			},
			onActiveChanged:	function(bActive)
			{
				var eActive

				if(this._role() === "server")
				{
					eActive = this._element("active")
					eActive.textContent = bActive ? "Active" : "Inactive"
					eActive.setAttribute("data-active", bActive ? "true" : "false")
					this._send({type: "status", value: bActive ? "active" : "inactive"})
					if(!bActive)
					{
						this._clients().slice().forEach
						(
							(oClient) =>
							{
								this._send({target: oClient.id, type: "transaction", value: "end"})
								this.remove(oClient.id)
							}
						)
					}
				}
			},
			onActiveClicked: function()
			{
				this._active(!this._active())
			},
			onAudioFinished: function()
			{
				var	oPhrase,
					eQuestion

				if(this._role() === "server")
				{
					oPhrase = this._element("clients").querySelector(`[data-id="${this.active("client")}"]`).getAttribute("data-phrase")
				}
				else
				{
					oPhrase = document.documentElement.getAttribute("data-phrase")
				}
				oPhrase	= this._phrase(oPhrase)
				eQuestion	= this._element("question")

				this	._send({type: "playback", value: this._role() === "server" ? this.active("client") : "server"})
					.stop("local")
					._filterPhrases(oPhrase.answers)
				if(oPhrase.answers.length)
				{
					eQuestion.textContent = oPhrase.sentence
					eQuestion.classList.remove("hidden")
				}
				else
				{
					eQuestion.textContent = ""
					eQuestion.classList.add("hidden")
				}
			},
			onClientClicked: function(oEvent)
			{
				var eElement

				for(eElement = oEvent.target; eElement.tagName !== "LI"; eElement = eElement.parentElement){}
				if(eElement.getAttribute("data-transaction") === "true")
				{
					let	oPhrase,
						eQuestion

					oPhrase	= this._phrase(eElement.getAttribute("data-phrase")) || null
					eQuestion	= this._element("question")

					this.active("client", eElement.getAttribute("data-id"))
					if(oPhrase !== null)
					{
						this._filterPhrases(oPhrase.answers)
						if(oPhrase.answers.length)
						{
							eQuestion.textContent = oPhrase.sentence
							eQuestion.classList.remove("hidden")
						}
						else
						{
							eQuestion.textContent = ""
							eQuestion.classList.add("hidden")
						}
					}
					else
					{
						this._filterPhrases()
						eQuestion.textContent = ""
						eQuestion.classList.add("hidden")
					}
				}
			},
			onCommandTimeout: function(sCommand)
			{
				this._send(this._queue("commands").get(sCommand).data)
			},
			onHomeClicked:	function()
			{
				this.reload()
			},
			onIdleTimeElapsed: function()
			{
				this._send({type: "transaction", value: "end"})
				this.reload()
			},
			onLanguageClicked:	function(oEvent)
			{
				if(this._role() === "client")
				{
					this	._send({type: "transaction", value: "start"})
						._timer("idle", window.setTimeout(this.onIdleTimeElapsed, this._timeout("idle")))
				}
				this.toSentences(oEvent.target.parentElement.getAttribute("data-language"))
			},
			onPingTimeElapsed: function()
			{
				this	._send({type: "ping", value: this._randomString(16)})
					._keepalive("timer", window.setTimeout(this.onPongTimeElapsed, this._timeout("pong")))
			},
			onPongTimeElapsed: function()
			{
				this._websocket().close()
				console.log("Websocket: disconnected, server did not respond")
			},
			onRoleChanged: function(sRole)
			{
				var	eRole

				document.documentElement.setAttribute("data-role", sRole)
				if(sRole === "server")
				{
					if(this._language() !== null)
					{
						this._element("active").removeAttribute("disabled")
					}
				}
				else
				{
					this._element("active").setAttribute("disabled", true)
				}
			},
			onScrollDownClicked: function()
			{
				this.scrollDown()
			},
			onScrollUpClicked: function()
			{
				this.scrollUp()
			},
			onSentenceClicked:	function(oEvent)
			{
				var	oPhrase

				oPhrase = this._phrase(oEvent.target.parentElement.parentElement.getAttribute("data-id"))

				if(this._role() === "server")
				{
					let eClient

					eClient = this._element("clients").querySelector("li[data-id=\"" + this.active("client") + "\"]")

					if(eClient !== null && eClient.getAttribute("data-transaction") === "true")
					{
						let eQuestion

						eQuestion = this._element("question")

						this.play("remote", oPhrase.id)
						eClient.setAttribute("data-phrase", oPhrase.id)
						this._filterPhrases(oPhrase.answers)
						if(oPhrase.answers.length)
						{
							eQuestion.textContent = oPhrase.sentence
							eQuestion.classList.remove("hidden")
						}
						else
						{
							eQuestion.textContent = ""
							eQuestion.classList.add("hidden")
						}
					}
				}
				else
				{
					if(document.documentElement.getAttribute("data-transaction") === "true")
					{
						let eQuestion

						eQuestion = this._element("question")

						this	.play("remote", oPhrase.id)
							._timer("idle", window.setTimeout(this.onIdleTimeElapsed, this._timeout("idle")))
						this._filterPhrases(oPhrase.answers)
						if(oPhrase.answers.length)
						{
							eQuestion.textContent = oPhrase.sentence
							eQuestion.classList.remove("hidden")
						}
						else
						{
							eQuestion.textContent = ""
							eQuestion.classList.add("hidden")
						}
					}
					else
					{
						this._queue("remote", oEvent.currentTarget)
					}

				}
			},
			onTransactionClicked: function(oEvent)
			{
				var eElement

				for(eElement = oEvent.target; eElement.tagName !== "LI"; eElement = eElement.parentElement){}
				if(eElement.getAttribute("data-transaction") === "true")
				{
					this._send({target: eElement.getAttribute("data-id"), type: "transaction", value: "end"})
					eElement.setAttribute("data-transaction", false)
					eElement.lastElementChild.textContent = "Gespräch übernehmen"
					eElement.classList.add("hidden")
					this._filterPhrases()
					eElement = this._element("question")
					eElement.textContent = ""
					eElement.classList.add("hidden")
					this.switch()
				}
				else
				{
					this._send({target: eElement.getAttribute("data-id"), type: "transaction", value: "accept"})
					eElement.setAttribute("data-transaction", true)
					eElement.lastElementChild.textContent = "Gespräch beenden"
					this.switch(eElement.getAttribute("data-id"))
				}
			},
			onUnload: function()
			{
				this.finalize();
			},
			onWebSocketClosed: function()
			{
				//window.clearTimeout(this._keepalive("timer"))
				//this._keepalive("timer", null)
				window.setTimeout(() => {this._websocket(null)}, this._timeout("websocket"))
				this._overlay("websocket")
			},
			onWebSocketMessage: function(sMessage)
			{
				var 	oData

				oData = JSON.parse(sMessage.data)

				switch(oData.type)
				{
					case "acknowledge":
						window.clearTimeout(this._queue("commands").get(oData.value).timer)
						this._queue("commands").delete(oData.value)
						break
					case "client":
						if(typeof oData.value === "string")
						{
							this.remove(oData.value)
						}
						else if(typeof oData.value === "object")
						{
							this._clients().push(oData.value)
							this.create("client", oData.value)
						}
						break
					case "id":
						this._id(oData.value)
						break
					case "language":
						if(this._role() === "server")
						{
							this.client(oData.target).language = oData.value
							this.flag(oData.value, this._element("clients").querySelector("li[data-id=\"" + oData.target + "\"] img"))
							if(this.active("client") === oData.target)
							{
								this.flag(oData.value, this._element("client"))
							}
						}
						break
					case "name":
						this._name(oData.value)
						break
					case "pause":
						this	._send({type: "status", value: "paused"})
							._overlay("server")
						break
					case "ping":
						//window.clearTimeout(this._keepalive("timer"))
						this	._send({type: "pong", value: oData.value})
							//._keepalive("timer", window.setTimeout(this.onPingTimeElapsed, this._timeout("ping")))
						break
					case "play":
						if(!this.isPlaying("local"))
						{
							if(this._role() === "server")
							{
								Array.prototype.find.call
								(
									this._element("clients").children,
									eClient => eClient.getAttribute("data-id") === oData.id
								).setAttribute("data-phrase", oData.value)
							}
							else
							{
								document.documentElement.setAttribute("data-phrase", oData.value)
							}
							if(this._role() === "server" && oData.id !== this.active("client"))
							{
								this.switch(oData.id)
							}
							this	.play("local", oData.value)
								._timer("idle", window.setTimeout(this.onIdleTimeElapsed, this._timeout("idle")))
						}
						else
						{
							this._queue("local").set(oData.id, oData.value)
						}
						break
					case "playback":
						// catch when it was aborted
						this.stop("remote")
						break
					case "reload":
						this.reload()
						break
					case "role":
						this._role(oData.value)
						break
					case "stop":
						this.stop(oData.value)
						break
					case "transaction":
						let eElement

						if(this._role() === "server")
						{
							eElement = this._element("clients")
								.querySelector("li[data-id=\"" + oData.target + "\"]")
						}

						switch(oData.value)
						{
							case "accepted":
								eElement.classList.add("hidden");
								break
							case "end":
								if(this._role() === "server")
								{
									eElement.setAttribute("data-transaction", false)
									eElement.classList.add("hidden")
									if(this.active("client") === oData.target)
									{
										this.switch()
									}
								}
								else
								{
									let fRestart = () =>
									{
										if(!this.isPlaying("local"))
										{
											this.reload()
										}
										else
										{
											window.setTimeout(fRestart, this._timeout("restartWait"))
										}
									}

									document.documentElement.setAttribute("data-transaction", false)
									fRestart()
								}
								break
							case "start":
								if(this._role() === "server")
								{
									eElement.classList.remove("hidden")
									this.highlight("client", eElement)
								}
								else
								{
									document.documentElement.setAttribute("data-transaction", true)
									if(this._queue("remote") != null)
									{
										this._queue("remote").click()
										this._queue("remote", null)
									}
								}
								break
						}

				}
			},
			onWebSocketOpen: function()
			{
				/*if(this._keepalive("timer") !== null)
				{
					window.clearTimeout(this._keepalive("timer"))
				}*/
				if(this._overlay() !== null)
				{
					this._overlay(null)
				}
				this	._send({type: "id"	, value: this._id()	})
					._send({type: "role"	, value: this._role() 	})
					._send({type: "name"	, value: this._name()	})
					._send({type: "status"	, value: "ready"	})
				if(this._language() !== null)
				{
					this._send({type: "language", value: this._language()})
					if(this._role() === "client")
					{
						this._send({type: "transaction", value: "start"})
					}
				}
				if(this._role() === "server")
				{
					this._send({type: "status", value: this._active() ? "active" : "inactive"})
				}
				//this._keepalive("timer", window.setTimeout(this.onPingTimeElapsed, this._timeout("ping")))
			},
			// </editor-fold>
			/*
			 ######  ######## ########  ##     ##  ######  ########  #######  ########   ######
			##    ##    ##    ##     ## ##     ## ##    ##    ##    ##     ## ##     ## ##    ##
			##          ##    ##     ## ##     ## ##          ##    ##     ## ##     ## ##
			 ######     ##    ########  ##     ## ##          ##    ##     ## ########   ######
			      ##    ##    ##   ##   ##     ## ##          ##    ##     ## ##   ##         ##
			##    ##    ##    ##    ##  ##     ## ##    ##    ##    ##     ## ##    ##  ##    ##
			 ######     ##    ##     ##  #######   ######     ##     #######  ##     ##  ######
			*/
			// <editor-fold desc="constructor/destructor">
			initialize:	function()
			{
				var	oQuery

				oQuery	= this._query()

				this.onActionClicked	= this.onActionClicked	.bind(this)
				this.onActiveClicked	= this.onActiveClicked	.bind(this)
				this.onAudioFinished	= this.onAudioFinished	.bind(this)
				this.onClientClicked	= this.onClientClicked	.bind(this)
				this.onHomeClicked	= this.onHomeClicked	.bind(this)
				this.onIdleTimeElapsed	= this.onIdleTimeElapsed	.bind(this)
				this.onLanguageClicked	= this.onLanguageClicked	.bind(this)
				this.onPingTimeElapsed	= this.onPingTimeElapsed	.bind(this)
				this.onPongTimeElapsed	= this.onPongTimeElapsed	.bind(this)
				this.onScrollDownClicked	= this.onScrollDownClicked	.bind(this)
				this.onScrollUpClicked	= this.onScrollUpClicked	.bind(this)
				this.onSentenceClicked	= this.onSentenceClicked	.bind(this)
				this.onTransactionClicked	= this.onTransactionClicked	.bind(this)
				this.onUnload	= this.onUnload	.bind(this)
				this.onWebSocketClosed	= this.onWebSocketClosed	.bind(this)
				this.onWebSocketMessage	= this.onWebSocketMessage	.bind(this)
				this.onWebSocketOpen	= this.onWebSocketOpen	.bind(this)

				this	._element("active"	, document.querySelector("#active"	))
					._element("audio"	, document.querySelector("#audio"	))
					._element("client"	, document.querySelector("#client"	))
					._element("clients"	, document.querySelector("#clients"	))
					._element("content"	, document.querySelector("#content"	))
					._element("home"	, document.querySelector("#home"	))
					._element("language"	, document.querySelector("#language"	))
					._element("languages"	, document.querySelector("#languages"	))
					._element("question"	, document.querySelector("#question"	))
					._element("sentences"	, document.querySelector("#sentences"	))

				document.querySelector	("#footer button:first-of-type"	)	.addEventListener("click"	, this.onScrollUpClicked	)
				document.querySelector	("#footer button:last-of-type"	)	.addEventListener("click"	, this.onScrollDownClicked	)
				this._element	("active"	)	.addEventListener("click"	, this.onActiveClicked	)
				this._element	("audio"	)	.addEventListener("ended"	, this.onAudioFinished	)
				this._element	("home"	)	.addEventListener("click"	, this.onHomeClicked	)
				window			.addEventListener("beforeunload"	, this.onUnload	)

				Promise.all
				(
					[
						this._xhr("GET", "./settings.json"),
						this._xhr("GET", "../wrapper.php?action=jdialog_lang_list")
					]
				)
				.then
				(
					([sSettings, sData]) =>
					{
						this	._parseSettings(sSettings)
							._data(JSON.parse(sData))
							._id	(oQuery.id	|| (this._randomNumber(1000000, 9999999).toString())	)
							._name	(oQuery.name	|| "Client " + this._id()	)
							._role	(oQuery.role	|| null	)
							._language	(oQuery.language	|| null	)
							._websocket	(null		)
							._active	(false		)

						if(oQuery.language !== undefined && oQuery.language !== "")
						{
							this.toSentences(oQuery.language)
						}
						else
						{
							this.create("languages")
						}
						if(this._role() === "server")
						{
							this.create("clients")
						}

						Array.prototype.slice.call(document.querySelectorAll(".actions > div"))
						.forEach
						(
							(eElement) =>
							{
								eElement.addEventListener("click", this.onActionClicked)
							}
						)
					}
				)

				return this;
			},
			finalize: function()
			{
				if(this._role() === "server")
				{
					this._active(false)
				}
				else
				{
					if(document.documentElement.getAttribute("data-transaction") === "true")
					{
						this._send({type: "transaction", value: "end"})
					}
				}
				this	._send({type: "status", value: "exiting"})
					._websocket().close()
			},
			// </editor-fold>
			/*
			##     ## ######## ######## ##     ##  #######  ########   ######
			###   ### ##          ##    ##     ## ##     ## ##     ## ##    ##
			#### #### ##          ##    ##     ## ##     ## ##     ## ##
			## ### ## ######      ##    ######### ##     ## ##     ##  ######
			##     ## ##          ##    ##     ## ##     ## ##     ##       ##
			##     ## ##          ##    ##     ## ##     ## ##     ## ##    ##
			##     ## ########    ##    ##     ##  #######  ########   ######
			*/
			// <editor-fold desc="methods">
			/*
			########  ########  #### ##     ##    ###    ######## ########
			##     ## ##     ##  ##  ##     ##  ##   ##     ##    ##
			########  ########   ##  ##     ## ##     ##    ##    ######
			##        ##   ##    ##   ##   ##  #########    ##    ##
			##        ##     ## ####    ###    ##     ##    ##    ########
			*/
			// <editor-fold desc="private">
			_filterPhrases: function(asIds)
			{
				var aeSentences

				aeSentences = this._element("sentences").lastElementChild.children

				if(asIds === undefined || asIds.length === 0)
				{
					$(aeSentences).show().css("background-color", "")
				}
				else
				{
					let sSelectors = ""

					asIds.forEach((sId) => {sSelectors += `[data-id="${sId}"],`})
					sSelectors = sSelectors.slice(0, -1)
					$(aeSentences)
						.not(sSelectors)
						.hide()
						.filter(":visible:nth-child(odd)")
						.css("background-color", "#efefef")
				}

				return this
			},
			_parseSettings: function(sSettings)
			{
				var oSettings

				oSettings = JSON.parse(sSettings)

				for(let sTimeout in oSettings.timeouts)
				{
					this._timeout(sTimeout, oSettings.timeouts[sTimeout])
				}
				for(let sUiSetting in oSettings.ui)
				{
					this["_" + sUiSetting](oSettings.ui[sUiSetting])
				}

				return this
			},
			_phrase: function(sId, sLanguage = this._language())
			{
				var	aoPhrases	,
					vReturnValue

					aoPhrases	= this._data(sLanguage).phrases

				if(Array.isArray(sId))
				{
					vReturnValue = aoPhrases.filter(oPhrase => sId.includes(oPhrase.id))
				}
				else
				{
					vReturnValue = aoPhrases.find(oPhrase => oPhrase.id === sId)
				}

				return vReturnValue
			},
			_randomNumber: function(nMinimum, nMaximum)
			{
				return Math.floor(Math.random() * (nMaximum - nMinimum + 1) + nMinimum)
			},
			_randomString: function(nLength)
			{
				var	sCharacters	,
					nCurrentCharacter	,
					sString

				sCharacters	= "0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ"
				sString	= ""

				for(nCurrentCharacter = 0; nCurrentCharacter < nLength; nCurrentCharacter++)
				{
					sString += sCharacters[this._randomNumber(0, sCharacters.length - 1)];
				}

				return sString;
			},
			_scrollSize: function()
			{
				// TODO: Add caching

				var	oStyle

				if(!this._element("languages").classList.contains("hidden"))
				{
					oStyle = window.getComputedStyle(document.querySelector("#languages > div"))
				}
				else if(!this._element("sentences").classList.contains("hidden"))
				{
					oStyle = window.getComputedStyle(document.querySelector("#sentences tr"))
				}

				return parseInt(oStyle.height) + parseInt(oStyle.borderTopWidth) + parseInt(oStyle.borderBottomWidth) + parseInt(oStyle.paddingTop) + parseInt(oStyle.paddingBottom) + parseInt(oStyle.marginTop) + parseInt(oStyle.marginBottom)
			},
			_send: function(oData = {})
			{
				if(this._websocket().readyState === 1)
				{
					let nTimer

					if(oData.id === undefined)
					{
						oData.id	= this._id()
					}
					if(oData.target === undefined)
					{
						oData.target = this._role() === "server" ? this.active("client") : null
					}
					if(oData.acknowledge === undefined)
					{
						for(oData.acknowledge = this._randomString(16); this._queue("commands").has(oData.acknowledge); ){}
					}
					this._websocket().send(JSON.stringify(oData))
					nTimer = window.setTimeout(() => {this.onCommandTimeout(oData.acknowledge)}, this._timeout("command"))
					this._queue("commands").set(oData.acknowledge, {data: oData, timer: nTimer})
				}

				return this
			},
			_sortPhrases: function(a, b)
			{
				a = window.parseInt(a.position)
				b = window.parseInt(b.position)

				if(a  <  b){return -1}
				if(a === b){return  0}
				if(a  >  b){return  1}
			},
			_xhr: function(sMethod, sUrl)
			{
				return new Promise
				(
					(fResolve, fReject) =>
					{
						var oXhr

						oXhr = new XMLHttpRequest()

						oXhr.addEventListener
						(
							"load",
							() =>
							{
								if(oXhr.status >= 200 && oXhr.status < 300)
								{
									fResolve(oXhr.response)
								}
								else
								{
									fReject({status: oXhr.status, statusText: oXhr.statusText})
								}
							}
						)
						oXhr.addEventListener
						(
							"error",
							() =>
							{
								fReject({status: oXhr.status, statusText: oXhr.statusText})
							}
						)

						oXhr.open(sMethod, sUrl)
						oXhr.send()
					}
				)
			},
			// </editor-fold>
			/*
			########  ##     ## ########  ##       ####  ######
			##     ## ##     ## ##     ## ##        ##  ##
			########  ##     ## ########  ##        ##  ##
			##        ##     ## ##     ## ##        ##  ##
			##         #######  ########  ######## ####  ######
			*/
			// <editor-fold desc="public">
			active: function(sType, vValue)
			{
				if(vValue === undefined)
				{
					let vReturnValue

					switch(sType)
					{
						case "client":
							vReturnValue = this._element("client").getAttribute("data-id")
							break
						case "sentences":
							vReturnValue = document.querySelector("#sentences tr.active")
							break
					}

					return vReturnValue
				}

				if(vValue === null)
				{
					switch(sType)
					{
						case "client":
							this.update("client", null)
							break
						case "sentences":
							vValue = this.active(sType)
							if(vValue !== null)
							{
								vValue.classList.remove("active")
							}
							break
					}
				}
				else
				{
					switch(sType)
					{
						case "client":
							this.update("client", this.client(vValue))
							break
						case "sentences":
							this.active(sType, null)
							vValue.classList.add("active")
							break
					}
				}

				return this
			},
			client: function(sClientId)
			{
				return this._clients().find((oClient) => {return oClient.id === sClientId})
			},
			create:	function(sType, vData)
			{
				var oDocumentFragment

				oDocumentFragment = $(document.createDocumentFragment())

				switch(sType)
				{
					case "client":
						oDocumentFragment.append
						(
							$("<li />")
							.attr
							({
								"data-id":	vData.id	,
								"data-phrase":	"null"	,
								"data-transaction":	false	,
							})
							.addClass("hidden")
							.on("click", this.onClientClicked)
							.append($("<img />").attr(this.flag(vData.language)))
							.append($("<span />").text(vData.name))
							.append
							(
								$("<button />")
								.text("Gespräch übernehmen")
								.on("click", this.onTransactionClicked)
							)
						)
						$(this._element("clients")).append(oDocumentFragment)
						break
					case "clients":
						oDocumentFragment.append
						(
							$("<div />")
							.attr("id", "clientList")
							.append
							(
								$("<div />")
								.attr("id", "client")
								.append($("<span />").text("Current Client:"))
								.append($("<img />").attr(this.flag(null)))
								.append($("<span />").text("-"))
							)
							.append($("<ul />").attr("id", "clients"))
						)
						this._element("client", oDocumentFragment[0].children[0].children[0])
						this._element("clients", oDocumentFragment[0].children[0].children[1])
						$("#header").after(oDocumentFragment)
						this._clients().forEach((oClient) => {this.create("client", oClient)})
						break
					case "languages":
						this._data().forEach
						(
							(oLanguage) =>
							{
								oDocumentFragment.append
								(
									$("<div />").attr("data-language", oLanguage.language.code)
									.append
									(
										$("<img />")	.attr(this.flag(oLanguage.language.code))
											.on("click", this.onLanguageClicked)
									)
								)
							}
						)
						$(this._element("languages")).append(oDocumentFragment)
						break
					case "sentences":
						let aoPhrase

						aoPhrase = this._data(vData).phrases.sort(this._sortPhrases)

						oDocumentFragment.append($("<table />"))
						aoPhrase.forEach
						(
							(oPhrase) =>
							{
								oDocumentFragment.children().eq(0).append
								(
									$("<tr />")
										.attr({"data-id": oPhrase.id, "data-sound": oPhrase.sound})
										.append($("<td />").text(oPhrase.position))
										.append
										(
											$("<td>").append
											(
												$("<img>")
												.attr(this.playButton("play"))
												.on("click", this.onSentenceClicked)
											)
										)
										.append
										(
											$("<td />").text(oPhrase.sentence)
										)
								)
							}
						)
						$(this._element("sentences")).append(oDocumentFragment)
						break
				}

				return this
			},
			flag: function(sLanguage, eElement)
			{
				var oData

				oData =
				{
					"alt":	"Flag " + (sLanguage === null ? "Unset" : this._data(sLanguage).country.name)	,
					"src":	"images/flags/" + (sLanguage === null ? "unset" : this._data(sLanguage).country.code.toLowerCase()) + ".svg"	,
				}

				if(!eElement)
				{
					return oData
				}

				Object.keys(oData).forEach
				(
					(sKey) =>
					{
						eElement.setAttribute(sKey, oData[sKey])
					}
				)

				return this
			},
			highlight: function(sType, eElement)
			{
				if(eElement === undefined)
				{
					let vReturnValue

					switch(sType)
					{
						case "client":
							vReturnValue = document.querySelector("#clientList .highlight")
							break
						case "sentences":
							vReturnValue = document.querySelector("#sentences tr.highlight")
							break
					}

					return vReturnValue
				}

				if(eElement === null)
				{
					let eElement

					eElement = this.highlight(sType)

					if(eElement !== null)
					{
						eElement.classList.remove("highlight")
					}
				}
				else
				{
					if(sType === "client")
					{
						if(this._timer("clientHighlight") !== null)
						{
							this.highlight("client", null)
						}
						this._timer("clientHighlight", window.setTimeout(() => {this.highlight("client", null)}, this._timeout("highlight")))
					}
					eElement.classList.add("highlight")
				}

				return this
			},
			isPlaying: function(sLocation)
			{
				if(sLocation === "local")
				{
					let eElement

					eElement = this._element("audio")

					return !eElement.ended && eElement.getAttribute("src") !== null && eElement.getAttribute("src") !== ""
				}
				else if(sLocation === "remote")
				{
					return this.active("sentences") !== null
				}
			},
			play: function(sLocation, sId)
			{
				var eElement

				eElement = document.querySelector
				(
						"#sentences tr:nth-child("
					+	this._phrase(sId).position
					+	")"
				)

				if(sLocation === "local")
				{
					eElement.scrollIntoViewIfNeeded()
					this	.highlight("sentences", eElement)
						._element("audio").setAttribute("src", eElement.getAttribute("data-sound"))
					this.playButton("playing", eElement.children[1].children[0])
				}
				else if(sLocation === "remote")
				{
					if(this._role() === "client" || (this._role() === "server" && this._clients().find((oClient) => {return oClient.id === this.active("client")}).language !== null))
					{
						if(this.isPlaying("remote"))
						{
							this.stop("remote")
						}
						this	.active("sentences", eElement)
							._send({type: "play", value: sId})
							.playButton("playing", eElement.children[1].children[0])
					}
				}

				return this
			},
			playButton: function(sType, eElement)
			{
				var oData

				oData =
				{
					"alt":	sType === "play" ? "Play" : "Playing"	,
					"src":	"images/" + (sType === "play" ? "play" : "playing") + ".svg"	,
				}

				if(!eElement)
				{
					return oData
				}

				Object.keys(oData).forEach
				(
					(sKey) =>
					{
						eElement.setAttribute(sKey, oData[sKey])
					}
				)

				return this
			},
			reload: function()
			{
				window.location.reload()

				return this
			},
			remove: function(sClientId)
			{
				this._clients().splice(this._clients().findIndex((oClient) => {return oClient.id === sClientId}), 1)
				$(this._element("clients").querySelector("li[data-id=\"" + sClientId + "\"]")).remove()
				this.switch()

				return this
			},
			scroll: function(nAmount)
			{
				var eElement

				eElement = this._element("content")

				if(nAmount > 0)
				{
					if(eElement.scrollTop + eElement.clientHeight < eElement.scrollHeight)
					{
						if(eElement.scrollTop + nAmount > eElement.scrollHeight)
						{
							eElement.scrollTop = eElement.scrollHeight
						}
						else
						{
							eElement.scrollTop += nAmount
						}
					}
				}
				else
				{
					if(eElement.scrollTop > 0)
					{
						if(eElement.scrollTop - nAmount < 0)
						{
							eElement.scrollTop = 0
						}
						else
						{
							eElement.scrollTop += nAmount
						}
					}
				}

				return this
			},
			scrollDown: function()
			{
				this.scroll(this._scrollSize())

				return this
			},
			scrollUp: function()
			{
				this.scroll(-this._scrollSize())

				return this
			},
			stop: function(sLocation)
			{
				var oNextInQueue

				if(sLocation === "local")
				{
					oNextInQueue = this._queue("local").keys().next()

					this._element("audio").pause()
					this	.playButton("play", this.highlight("sentences").children[1].children[0])
						.highlight("sentences", null)
					if(!oNextInQueue.done)
					{
						if(this._role() === "server")
						{
							this.switch(oNextInQueue.value)
						}
						this.play("local", this._queue("local").get(oNextInQueue.value))
						this._queue("local").delete(oNextInQueue.value)
					}
				}
				else if(sLocation === "remote")
				{
					if(this.active("sentences") !== null)
					{
						this	.playButton("play", this.active("sentences").children[1].children[0])
							.active("sentences", null)
					}
				}

				return this
			},
			switch: function(sId)
			{
				var eElement

				if(sId !== undefined)
				{
					eElement = this._element("clients").querySelector("li[data-id=\"" + sId + "\"]")

					eElement.click()
				}
				else
				{
					eElement = this._element("clients").querySelector("li[data-transaction=\"true\"]")

					if(eElement !== null)
					{
						eElement.click()
					}
					else
					{
						eElement = this._element("client")
						if(eElement !== null && eElement.hasAttribute("data-id"))
						{
							this.active("client", null)
						}
					}
				}

				return this
			},
			toSentences: function(sLanguage)
			{
				this._xhr("GET", `../wrapper.php?action=jdialog_phrases_list&level=1&jpl_id=${this._data(sLanguage).id}`)
				.then
				(
					(sSentences) =>
					{
						this	._data (sLanguage	,	JSON.parse(sSentences)	)
						.update	("language"	,	sLanguage	)
						._send	(		{type: "language", value: sLanguage}	)
						.create	("sentences"	,	sLanguage	)
						this	._element("languages").classList.add	("hidden")
						this	._element("sentences").classList.remove	("hidden")
						if(this._role() === "server")
						{
							this._active(this._query().active !== undefined ? this._query().active : true)
							this._element("active").removeAttribute("disabled")
						}
					}
				)

				return this
			},
			update: function(sType, vValue)
			{
				if(sType === "language")
				{
					this	._language	(vValue		)
						.flag	(vValue	, this._element("language")	)
				}
				else if(sType === "client" && this._role() === "server")
				{
					let eClient = this._element("client")

					if(vValue !== undefined && vValue !== null)
					{
						eClient.setAttribute("data-id", vValue.id)
						this.flag(vValue.language, eClient.children[1])
						eClient.children[2].textContent = vValue.name
					}
					else
					{
						eClient.removeAttribute("data-id")
						this.flag(vValue, eClient.children[1])
						eClient.children[2].textContent = "-"
					}

					this.highlight("client", this._element("client"))
					if(this.isPlaying("remote"))
					{
						this.stop("remote")
					}
				}

				return this
			},
			// </editor-fold>
			// </editor-fold>
		}

		document.addEventListener
		(
			"DOMContentLoaded",
			function()
			{
				oTranslator.initialize()
			}
		)
	}()
)
