(
	function()
	{
		"use strict"

		class Overlay
		{
			/*
			  ###  ######         ##  ######  ###   ######## ######## ######## ######## ########
			 ##   ##    ##       ##  ##    ##   ##  ##          ##       ##    ##       ##     ##
			##    ##            ##   ##          ## ##          ##       ##    ##       ##     ##
			##    ##   ####    ##     ######     ## ######      ##       ##    ######   ########
			##    ##    ##    ##           ##    ## ##          ##       ##    ##       ##   ##
			 ##   ##    ##   ##      ##    ##   ##  ##          ##       ##    ##       ##    ##
			  ###  ######   ##        ######  ###   ########    ##       ##    ######## ##     ##
			*/
			// <editor-fold desc="getter/setter">
			/*
			########  ########  #### ##     ##    ###    ######## ########
			##     ## ##     ##  ##  ##     ##  ##   ##     ##    ##
			########  ########   ##  ##     ## ##     ##    ##    ######
			##        ##   ##    ##   ##   ##  #########    ##    ##
			##        ##     ## ####    ###    ##     ##    ##    ########
			*/
			// <editor-fold desc="private">
			set _element(eElement)
			{
				this.oElements.eElement = eElement
			}
			// </editor-fold>
			/*
			########  ##     ## ########  ##       ####  ######
			##     ## ##     ## ##     ## ##        ##  ##
			########  ##     ## ########  ##        ##  ##
			##        ##     ## ##     ## ##        ##  ##
			##         #######  ########  ######## ####  ######
			*/
			// <editor-fold desc="public">
			get content()
			{
				return this.vContent
			}
			set content(vContent)
			{
				this.vContent = vContent
			}
			get element()
			{
				return this.oElements.eElement
			}
			get parent()
			{
				return this.oElements.eParent
			}
			set parent(eParent)
			{
				this.oElements.eParent = eParent
			}
			// </editor-fold>
			// </editor-fold>
			/*
			######## ##     ## ######## ##    ## ########  ######
			##       ##     ## ##       ###   ##    ##    ##    ##
			##       ##     ## ##       ####  ##    ##    ##
			######   ##     ## ######   ## ## ##    ##     ######
			##        ##   ##  ##       ##  ####    ##          ##
			##         ## ##   ##       ##   ###    ##    ##    ##
			########    ###    ######## ##    ##    ##     ######
			*/
			// <editor-fold desc="events">
			onUnload()
			{
				this.destructor()
			}
			// </editor-fold>
			/*
			  ###  ######   #######  ##    ##       ## ########  ######## ###    ######  ######## ########  ##     ##  ######  ########  #######  ########
			 ##   ##    ## ##     ## ###   ##      ##  ##     ## ##         ##  ##    ##    ##    ##     ## ##     ## ##    ##    ##    ##     ## ##     ##
			##    ##       ##     ## ####  ##     ##   ##     ## ##          ## ##          ##    ##     ## ##     ## ##          ##    ##     ## ##     ##
			##    ##       ##     ## ## ## ##    ##    ##     ## ######      ##  ######     ##    ########  ##     ## ##          ##    ##     ## ########
			##    ##       ##     ## ##  ####   ##     ##     ## ##          ##       ##    ##    ##   ##   ##     ## ##          ##    ##     ## ##   ##
			 ##   ##    ## ##     ## ##   ###  ##      ##     ## ##         ##  ##    ##    ##    ##    ##  ##     ## ##    ##    ##    ##     ## ##    ##
			  ###  ######   #######  ##    ## ##       ########  ######## ###    ######     ##    ##     ##  #######   ######     ##     #######  ##     ##
			*/
			// <editor-fold desc="constructor/destructor">
			constructor(eParent, vContent)
			{
				this.vContent	= null
				this.oElements	=
				{
					eElement:	null,
					eParent:	null,
				}

				this.content	= vContent	|| null
				this.parent	= eParent	|| null

				this.onUnload	= this.onUnload	.bind(this)

				window.addEventListener("beforeunload", this.onUnload)

				if(this.hasContent() && this.hasParent())
				{
					this.create()
				}

			}
			destructor()
			{
				this.destory()
			}
			// </editor-fold>
			/*
			##     ## ######## ######## ##     ##  #######  ########   ######
			###   ### ##          ##    ##     ## ##     ## ##     ## ##    ##
			#### #### ##          ##    ##     ## ##     ## ##     ## ##
			## ### ## ######      ##    ######### ##     ## ##     ##  ######
			##     ## ##          ##    ##     ## ##     ## ##     ##       ##
			##     ## ##          ##    ##     ## ##     ## ##     ## ##    ##
			##     ## ########    ##    ##     ##  #######  ########   ######
			*/
			// <editor-fold desc="methods">
			create(eParent, vContent)
			{
				var	oDocumentFragment

				vContent	= vContent	|| this.content
				eParent	= eParent	|| this.parent
				oDocumentFragment	= document.createDocumentFragment()

				if(eParent !== null && vContent !== null)
				{
					$(oDocumentFragment).append
					(
						$("<div />")
						.addClass("overlay")
						.css
						({
							height:	window.parseFloat($(eParent).outerHeight(true)	),
							left:	window.parseFloat(eParent.offsetLeft	),
							top:	window.parseFloat(eParent.offsetTop	),
							width:	window.parseFloat($(eParent).outerWidth(true)	),
						})
						.append($("<div />").addClass("overlay-shadow"))
						.append($("<div />").addClass("overlay-content").html(vContent))
					)

					this._element = oDocumentFragment.children[0]
					eParent.parentElement.insertBefore(oDocumentFragment, eParent.nextElementSibling)
				}

				return this
			}
			destroy()
			{
				if(this.isCreated())
				{
					this.element.remove()
					this._element = null
				}

				return this
			}
			hasContent()
			{
				var bReturnValue

				if(this.isCreated())
				{
					bReturnValue = this.element.children.length > 0
				}
				else
				{
					bReturnValue = this.content !== null
				}

				return bReturnValue
			}
			hasParent()
			{
				return this.parent !== null
			}
			isCreated()
			{
				return this.element !== null
			}
			// </editor-fold>
		}

		if(window.metasec === undefined)
		{
			window.metasec = {}
		}
		window.metasec.Overlay = Overlay
	}()
)
