(
	function()
	{
		let oUi

		oUi =
		{
			// TODO: Change readonly sourceText when no 2nd client
			// TODO: Change show flag unsset if no 2nd client or no language set
			// TODO: Change send empty string when sourceText is cleared

			bChangedLanguage:	false	,
			sState:	"start"	,
			nTypingWaitTimer:	null	,

			oElements:
			{
				aeMenuButtons:	null	,

				eAnswerText:	null	,
				eChat:	null	,
				eCurrentLanguages:	null	,
				eFooter:	null	,
				eLanguageList:	null	,
				eListen:	null	,
				eLogo:	null	,
				eSourceLanguage:	null	,
				eSourceText:	null	,
				eSpeak:	null	,
				eStatus:	null	,
				eTargetLanguage:	null	,
				eWelcome:	null	,
			},

			onAnswerTextReceived: function(sText)
			{
				this.display("answerText", sText)

				return this
			},
			onConnected: function()
			{
				this.display("status", "Connected")

				return this
			},
			onDisconnected: function()
			{
				this.display("status", "Disconnected")

				return this
			},
			onListen: function()
			{
				if(!Translator.isListening())
				{
					this	._active(this.oElements.eListen)
						.clean("sourceText")
					Translator.listen()
				}
				else
				{
					Translator.stopListening()
				}

				return this
			},
			onListened: function()
			{
				this._active(null)

				return this
			},
			onLogoClicked: function()
			{
				window.location.reload()
			},
			onRecognitionResult: function(sText)
			{
				this.display("sourceText", sText)
			},
			onShowLanguageSelection: function()
			{
				this.state("languageSelection")

				return this
			},
			onSourceLanguageChanged: function(sNewLanguage, sOldLanguage)
			{
				this.clean("sourceText")
				if(!this._isEmpty("answerText"))
				{
					this.bChangedLanguage = true
					Translator.translate(this._text("answerText"), sOldLanguage, sNewLanguage)
				}

				return this
			},
			onSourceLanguageSelected: function(oEvent)
			{
				var eElement

				if(oEvent.target.tagName !== "UL")
				{
					if(oEvent.target.tagName !== "LI")
					{
						eElement = oEvent.target.parentElement
					}
					else
					{
						eElement = oEvent.target
					}
					this.oElements.eSourceLanguage.setAttribute("src", eElement.children[0].getAttribute("src"))
					this.oElements.eSourceLanguage.setAttribute("alt", eElement.children[0].getAttribute("alt"))
					Translator.sourceLanguage(eElement.getAttribute("data-language"))
					// TODO: Add setting flag alt attribute
					this.state("chat")
				}

				return this
			},
			onSourceTextInput: function()
			{
				if(this.nTypingWaitTimer !== null)
				{
					window.clearTimeout(this.nTypingWaitTimer)
				}
				if(!this._isEmpty("sourceText"))
				{
					this.nTypingWaitTimer = window.setTimeout(this.onTypingWaitTimeElapsed, 750)
				}

				return this
			},
			onSpeak: function()
			{
				Translator.speak(this._text("answerText"))
				this._active(this.oElements.eSpeak)

				return this
			},
			onSpoken: function()
			{
				this._active(null)

				return this
			},
			onTargetLanguageChanged: function(sLanguage)
			{
				if(sLanguage === null)
				{
					this.oElements.eTargetLanguage.setAttribute("src", "images/flags/unset.svg")
					this.oElements.eTargetLanguage.setAttribute("alt", "Unset Flag")
				}
				else
				{
					this.oElements.eTargetLanguage.setAttribute("src", this.oElements.eLanguageList.querySelector("li[data-language=\"" + sLanguage + "\"] img").getAttribute("src"))
					this.oElements.eTargetLanguage.setAttribute("alt", this.oElements.eLanguageList.querySelector("li[data-language=\"" + sLanguage + "\"] img").getAttribute("alt"))
				}
				// TODO: Add setting flag alt attribute

				return this
			},
			onTranslated: function(sText)
			{
				if(this.hasChangedLanguage())
				{
					this.display("answerText", sText)
					this.bChangedLanguage = false
				}
			},
			onTypingWaitTimeElapsed: function()
			{
				Translator.translate(this._text("sourceText"))
				if(this.nTypingWaitTimer !== null)
				{
					this.nTypingWaitTimer = null
				}

				return this
			},
			onUnload: function()
			{
				this.finalize()

				return this
			},

			initialize: function()
			{
				this.onAnswerTextReceived	=	this.onAnswerTextReceived	.bind(this)
				this.onConnected	=	this.onConnected	.bind(this)
				this.onDisconnected	=	this.onDisconnected	.bind(this)
				this.onListen	=	this.onListen	.bind(this)
				this.onListened	=	this.onListened	.bind(this)
				this.onLogoClicked	=	this.onLogoClicked	.bind(this)
				this.onRecognitionResult	=	this.onRecognitionResult	.bind(this)
				this.onShowLanguageSelection	=	this.onShowLanguageSelection	.bind(this)
				this.onSourceLanguageChanged	=	this.onSourceLanguageChanged	.bind(this)
				this.onSourceLanguageSelected	=	this.onSourceLanguageSelected	.bind(this)
				this.onSourceTextInput	=	this.onSourceTextInput	.bind(this)
				this.onSpeak	=	this.onSpeak	.bind(this)
				this.onSpoken	=	this.onSpoken	.bind(this)
				this.onTargetLanguageChanged	=	this.onTargetLanguageChanged	.bind(this)
				this.onTranslated	=	this.onTranslated	.bind(this)
				this.onTypingWaitTimeElapsed	=	this.onTypingWaitTimeElapsed	.bind(this)
				this.onUnload	=	this.onUnload	.bind(this)

				this.oElements.aeMenuButtons	=	Array.prototype.slice.call(	document.querySelectorAll	(".menuButton"	))
				this.oElements.eAnswerText	=		document.querySelector	("#answerText"	)
				this.oElements.eChat	=		document.querySelector	("#chat"	)
				this.oElements.eCurrentLanguages	=		document.querySelector	("#currentLanguages"	)
				this.oElements.eFooter	=		document.querySelector	("#footer"	)
				this.oElements.eLanguageList	=		document.querySelector	("#languageList"	)
				this.oElements.eListen	=		document.querySelector	("#listen"	)
				this.oElements.eLogo	=		document.querySelector	("#logo"	)
				this.oElements.eSourceLanguage	=		document.querySelector	("#currentLanguages li:first-of-type img"	)
				this.oElements.eSourceText	=		document.querySelector	("#sourceText"	)
				this.oElements.eSpeak	=		document.querySelector	("#speak"	)
				this.oElements.eStatus	=		document.querySelector	("#status"	)
				this.oElements.eTargetLanguage	=		document.querySelector	("#currentLanguages li:last-of-type img"	)
				this.oElements.eWelcome	=		document.querySelector	("#welcome"	)

				this.oElements.aeMenuButtons	.forEach((eElement) => {eElement	.addEventListener("click"	,	this.onShowLanguageSelection	)})
				this.oElements.eLanguageList		.addEventListener("click"	,	this.onSourceLanguageSelected	)
				this.oElements.eListen		.addEventListener("click"	,	this.onListen	)
				this.oElements.eLogo		.addEventListener("click"	,	this.onLogoClicked	)
				this.oElements.eSourceText		.addEventListener("input"	,	this.onSourceTextInput	)
				this.oElements.eSpeak		.addEventListener("click"	,	this.onSpeak	)
				Connector		.addEventListener("answerTextReceived"	,	this.onAnswerTextReceived	)
				Connector		.addEventListener("connected"	,	this.onConnected	)
				Connector		.addEventListener("disconnected"	,	this.onDisconnected	)
				Translator		.addEventListener("listened"	,	this.onListened	)
				Translator		.addEventListener("recognitionResult"	,	this.onRecognitionResult	)
				Translator		.addEventListener("recognitionPartialResult"	,	this.onRecognitionResult	)
				Translator		.addEventListener("sourceLanguageChanged"	,	this.onSourceLanguageChanged	)
				Translator		.addEventListener("spoken"	,	this.onSpoken	)
				Translator		.addEventListener("targetLanguageChanged"	,	this.onTargetLanguageChanged	)
				Translator		.addEventListener("translated"	,	this.onTranslated	)
				window		.addEventListener("beforeunload"	,	this.onUnload	)

				return this
			},
			finalize: function()
			{
				this.oElements.aeMenuButtons	.forEach((eElement) => {eElement	.removeEventListener("click"	,	this.onShowLanguageSelection	)})
				this.oElements.eLanguageList		.removeEventListener("click"	,	this.onSourceLanguageSelected	)
				this.oElements.eListen		.removeEventListener("click"	,	this.onListen	)
				this.oElements.eLogo		.removeEventListener("click"	,	this.onLogoClicked	)
				this.oElements.eSourceText		.removeEventListener("input"	,	this.onSourceTextInput	)
				this.oElements.eSpeak		.removeEventListener("click"	,	this.onSpeak	)
				Connector		.removeEventListener("answerTextReceived"	,	this.onAnswerTextReceived	)
				Connector		.removeEventListener("connected"	,	this.onConnected	)
				Connector		.removeEventListener("disconnected"	,	this.onDisconnected	)
				Translator		.removeEventListener("listened"	,	this.onListened	)
				Translator		.removeEventListener("sourceLanguageChanged"	,	this.onSourceLanguageChanged	)
				Translator		.removeEventListener("spoken"	,	this.onSpoken	)
				Translator		.removeEventListener("targetLanguageChanged"	,	this.onTargetLanguageChanged	)
				Translator		.removeEventListener("translated"	,	this.onTranslated	)
				window		.removeEventListener("beforeunload"	,	this.onUnload	)

				Object.keys(this.oElements).forEach((sElement) => {this.oElements[sElement] = null})

				return this
			},

			_active: function(eElement)
			{
				if(eElement === undefined)
				{
					return document.querySelector("#chat button.active")
				}

				if(typeof eElement !== "object" && eElement !== null)
				{
					throw new TypeError
					(
							"incorrect type or unusable value"
						+	"\nMethod: \"Ui.active\""
						+	"\nArgument: \"element\""
						+	"\nType: expected [object|null] found \"" + typeof eElement + "\""
						+	"\nValue: expected [HTMLButtonElement|null] found \"" + eElement + "\""
					)
				}


				if(eElement === null)
				{
					if(this._active())
					{
						this._active().classList.remove("active")
					}
				}
				else
				{
					if(this._active())
					{
						this._active().classList.remove("active")
					}
					eElement.classList.add("active")
				}

				return this
			},
			_isEmpty: function(sField)
			{
				if(typeof sField !== "string" || (sField !== "answerText" && sField !== "sourceText" && sField !== "status"))
				{
					throw new TypeError
					(
							"incorrect type or unusable value"
						+	"\nMethod: \"Ui._isEmpty\""
						+	"\nArgument: \"field\""
						+	"\nType: expected \"string\" found \"" + typeof sField + "\""
						+	"\nValue: expected [answerText|sourceText|status] found \"" + sField + "\""
					)
				}

				return this._text(sField) === ""
			},
			_query: function()
			{
				var oData

				oData = {}

				window.location.search.substr(1).split("&").forEach
				(
					(sPair) =>
					{
						var asPair

						asPair = sPair.split("=")

						oData[asPair[0]] = asPair[1]
					}
				)

				return oData
			},
			_text: function(sField)
			{
				if(typeof sField !== "string" || (sField !== "answerText" && sField !== "sourceText" && sField !== "status"))
				{
					throw new TypeError
					(
							"incorrect type or unusable value"
						+	"\nMethod: \"Ui._text\""
						+	"\nArgument: \"field\""
						+	"\nType: expected \"string\" found \"" + typeof sField + "\""
						+	"\nValue: expected [answerText|sourceText|status] found \"" + sField + "\""
					)
				}

				return this._textElement(sField).value
			},
			_textElement: function(sField)
			{
				if(typeof sField !== "string" || (sField !== "answerText" && sField !== "sourceText" && sField !== "status"))
				{
					throw new TypeError
					(
							"incorrect type or unusable value"
						+	"\nMethod: \"Ui._textFieldElement\""
						+	"\nArgument: \"field\""
						+	"\nType: expected \"string\" found \"" + typeof sField + "\""
						+	"\nValue: expected [answerText|sourceText|status] found \"" + sField + "\""
					)
				}

				return this.oElements["e" + sField[0].toUpperCase() + sField.slice(1)]
			},

			clean: function(sField)
			{
				if(typeof sField !== "string" || (sField !== "answerText" && sField !== "sourceText" && sField !== "status"))
				{
					throw new TypeError
					(
							"incorrect type or unusable value"
						+	"\nMethod: \"Zi.clean\""
						+	"\nArgument: \"field\""
						+	"\nType: expected \"string\" found \"" + typeof sField + "\""
						+	"\nValue: expected [answerText|sourceText|status] found \"" + sField + "\""
					)
				}

				this.display(sField, "")

				return this
			},
			display: function(sField, sText)
			{
				var eElement

				if(typeof sField !== "string" || (sField !== "answerText" && sField !== "sourceText" && sField !== "status"))
				{
					throw new TypeError
					(
							"incorrect type or unusable value"
						+	"\nMethod: \"Ui.display\""
						+	"\nArgument: \"field\""
						+	"\nType: expected \"string\" found \"" + typeof sField + "\""
						+	"\nValue: expected [answerText|sourceText|status] found \"" + sField + "\""
					)
				}
				if(typeof sText !== "string")
				{
					throw new TypeError
					(
							"incorrect type or unusable value"
						+	"\nMethod: \"Ui.display\""
						+	"\nArgument: \"text\""
						+	"\nType: expected \"string\" found \"" + typeof sText + "\""
						+	"\nValue: expected [\"\"|!\"\"] found \"" + sText + "\""
					)
				}

				eElement = this._textElement(sField)

				if(eElement.tagName === "TEXTAREA")
				{
					eElement.innerHTML	= sText
					eElement.value	= eElement.innerHTML
					eElement.innerHTML	= ""
				}
				else
				{
					eElement.innerHTML = sText
				}

				return this
			},
			hasChangedLanguage: function()
			{
				return this.bChangedLanguage
			},
			state: function(sNewState)
			{
				let sCurrentState

				if(sNewState === undefined)
				{
					return this.sState
				}

				if(typeof sNewState !== "string" || (sNewState !== "start" && sNewState !== "languageSelection" && sNewState !== "chat"))
				{
					throw new TypeError
					(
							"incorrect type or unusable value"
						+	"\nMethod: \"Ui.state\""
						+	"\nArgument: \"newState\""
						+	"\nType: expected \"string\" found \"" + typeof sNewState + "\""
						+	"\nValue: expected [start|languageSelection|chat] found \"" + sNewState + "\""
					)
				}

				sCurrentState = this.state()

				if(sCurrentState !== sNewState)
				{
					if(sCurrentState === "chat")
					{
						this.oElements.eCurrentLanguages	.classList.add	("hidden")
						this.oElements.aeMenuButtons[0]	.classList.add	("hidden")
						this.oElements.eChat	.classList.add	("hidden")
						this.oElements.eWelcome	.classList.remove	("hidden")
						if(sNewState === "languageSelection")
						{
							this.oElements.eFooter	.classList.add	("hidden")
							this.oElements.eLanguageList	.classList.remove	("hidden")
							this.	_active	(null)
							Translator	.stopListening	()
								.stopSpeaking	()
							this.display("sourceText", "")
						}
					}
					else if(sCurrentState === "languageSelection")
					{
						this.oElements.eLanguageList	.classList.add	("hidden")
						this.oElements.eFooter	.classList.remove	("hidden")
						if(sNewState === "chat")
						{
							this.oElements.eWelcome	.classList.add	("hidden")
							this.oElements.eChat	.classList.remove	("hidden")
							this.oElements.eCurrentLanguages	.classList.remove	("hidden")
							this.oElements.aeMenuButtons[0]	.classList.remove	("hidden")

							this.oElements.eSourceText.focus()
						}
					}
					else if(sCurrentState === "start")
					{
						if(sNewState === "chat")
						{
							this.oElements.eWelcome	.classList.add	("hidden")
							this.oElements.eChat	.classList.remove	("hidden")
							this.oElements.eCurrentLanguages	.classList.remove	("hidden")
							this.oElements.aeMenuButtons[0]	.classList.remove	("hidden")

							this.oElements.eSourceText.focus()
						}
						else if(sNewState === "languageSelection")
						{
							this.oElements.eFooter	.classList.add	("hidden")
							this.oElements.eLanguageList	.classList.remove	("hidden")
						}
					}

					this.sState = sNewState
				}

				return this
			},
		}

		document.addEventListener
		(
			"DOMContentLoaded",
			function()
			{
				oUi.initialize()
			}
		)
		window.Ui = oUi
	}()
)
